class GroupController < ApplicationController
  layout  'gfdnavi'

  before_filter :login_required

  def create
    case @request.method
    when :post
      user = session[:user]
      if (group = user.own_groups.create(params[:group]))
        group.group_members.create(:user => user)
        flash['notice']  = "Create group successful"
        redirect_back_or_default :action => "list"
      end
    when :get
      @group = Group.new
    end
  end

  def delete
    user = session[:user]
    group = Group.find_by_id(params[:id])
    if group
      if group.owner == user || User.super_user?(user)
        group.destroy
      end
    end
    redirect_back_or_default :action => "list"
  end

  def add_member
    case @request.method
    when :post
      if ( group = Group.find_by_id(params[:id]) )
        user = session[:user]
        if User.super_user?(user) || group.owner == user
          unless group.members.find_by_login(params[:user])
            if ( member = User.find_by_login(params[:user]) )
              group.group_members.create(:user => member)
            end
          end
        end
      end
      redirect_back_or_default :action => "list"
    when :get
      @group = Group.find_by_id(params[:id])
    end
  end

  def delete_member
    case @request.method
    when :post
      if ( group = Group.find_by_id(params[:id]) )
        user = session[:user]
        if User.super_user?(user) || group.owner == user
          if ( member = group.members.find_by_login(params[:user]) )
            if ( member = group.group_members.find_by_user_id(member.id) )
              group.group_members.delete member
            end
          end
        end
      end
      redirect_back_or_default :action => "list"
    when :get
      @group = Group.find_by_id(params[:id])
    end
  end

  def list
    user = session[:user]
    if User.super_user?(user)
      @own_groups = Group.find(:all)
    else
      @own_groups = user.own_groups(true)
    end
    @belonging_groups = user.belonging_groups(true)
  end

end
