class ImageController < ApplicationController

  def show
    raise 'you need to give me a path as a parameter' if !params[:path]
    var = Variable.find_for_user( session[:user], :first, \
                           { :conditions => [ "path = ?",params[:path] ] } )
    raise("#{params[:path]} is not available") if var.nil?
    response.headers['Content-Type'] = _content_type(params[:path])
    internal_path = var.file_and_variable_names[0]
    render(:text => File.read(internal_path) )
  end

  def _content_type(filename)
    case filename
    when /\.png$/i
      'image/png'
    when /\.jpeg$|\.jpg$/i
      'image/jpeg'
    when /\.gif$/i
      'image/gif'
    when /\.tiff?$/i
      'image/tiff'
    when /\.xwd?$/i
      'image/xwindowdump'
    else
      raise "#{params[:path]} Not a image file or unsupported image type (which can be easily extended. Contact the gfdnavi developpers.)"
    end
  end

end
