require File.dirname(__FILE__) + '/../test_helper'

class KeywordAttributeTest < Test::Unit::TestCase
  fixtures :keyword_attributes, :directories, :variables

  def setup
    @ka = KeywordAttribute.find(1)
  end

  def test_create
    rd = keyword_attributes(:reanalysis_description)
    assert_kind_of KeywordAttribute, @ka
    assert_equal rd.variable_id, @ka.variable_id
    assert_equal rd.directory_id, @ka.directory_id
    assert_equal rd.name, @ka.name
    assert_equal rd.value, @ka.value
    assert_equal rd.num_value, @ka.num_value
  end

  def test_directory
    dir = directories(:reanalysis)
    assert_kind_of Directory, @ka.directory
    assert_equal dir, @ka.directory
  end

  def test_variable
    var = variables(:ncep_jan_u)
    ka = KeywordAttribute.find(5)
    assert_kind_of Variable, ka.variable
    assert_equal var, ka.variable
  end

  def test_stdname
    ka = variables(:ncep_jan_u).keyword_attributes.find_by_stdname('title')
    assert_equal 'long_name', ka.name
  end

end
